<?php
require_once UCD_APPLICATION_PATH . '/controllers/Abstract/Admin.php';

class Ucd_Controller_ActivateController
    extends Ucd_Controller_Abstract_Admin
{
    public function init()
    {
        parent::init();

        $layout = $this->_view->layout;

        $layout->hideAllNotices = TRUE;
    }

    public function indexAction()
    {
        $form = Ucd_Application::getForm('Activate');

        if ($_POST) {
            if (!$form->isValid($_POST)) {
                foreach ($form->getElements() as $element) {
                    foreach ($element->getMessages() as $message) {
                        $this->_addMessage(
                            $this->_view->escape("{$element->getLabel()}: {$message}"),
                            'error');
                    }
                }
            } else {
                $service = Ucd_Application::getService('Activate');

                try {
                    $result = $service->activate($form->getValue('activate_email'));
                    if (!$result) {
                        $this->_addMessage(
                            "No license found for {$form->getValue('activate_email')}.",
                            'error');
                    } else {
                        $this->_addMessage(
                            Ucd_WpPlugin::TITLE . ' has been successfully activated.',
                            'updated');
                        $this->_viewScript = NULL;
                        $_POST = array();
                        Ucd_WpPlugin::getInstance()->dispatch('admin');
                        return;
                    }
                } catch (Ucd_Service_Activate_Exception $e) {
                    $this->_addMessage("Error sending activation request: {$e->getMessage()}",
                        'error');
                }
            }
        }

        return array(
            'form' => $form,
        );
    }
}