<?php
class Ucd_Service_Activate
{
    public function activate($activateEmail)
    {
        $result = $this->_inquiry($activateEmail);

        if ($result) {
            Ucd_WpPlugin::$components['activate']->activate($activateEmail);
        }

        return $result;
    }

    public function verify($activateEmail)
    {
        $result = $this->_inquiry($activateEmail, TRUE);

        if (!$result) {
            Ucd_WpPlugin::$components['activate']->deactivate();
        }

        return $result;
    }

    protected function _inquiry($activateEmail, $verify=FALSE)
    {
        $params = array(
            'client_email' => $activateEmail,
            'product_name' => Ucd_WpPlugin::$components['activate']->productName,
            'site_url' => site_url(),
            'type' => $verify? 'verification': 'activation',
        );

        return $this->_request($params);
    }

    protected function _request(array $params)
    {
        $url = Ucd_WpPlugin::$components['activate']->apiUrl;

        $curl = curl_init($url);

        // options
        curl_setopt_array($curl, array(
            CURLOPT_POST => TRUE,
            CURLOPT_POSTFIELDS => http_build_query($params, '', '&'),
            CURLOPT_FAILONERROR => TRUE,
            CURLOPT_RETURNTRANSFER => TRUE,
        ));

        // execute post
        $result = curl_exec($curl);
        if (FALSE === $result) {
            $error = curl_error($curl);
            curl_close($curl);
            throw new Ucd_Service_Activate_Exception($error);
        }

        $result = json_decode($result, TRUE);
        if (!$result || !isset($result['valid'])) {
            throw new Ucd_Service_Activate_Exception('Cannot decode response.');
        }

        // lose connection
        curl_close($curl);

        return $result['valid'];
    }
}

class Ucd_Service_Activate_Exception extends Exception
{

}